macroScript Quick_tangents
category:"Brads"
tooltip: "Quick tangents"
Icon:#("TrackViewKeyTangents",1)

(
	selKeyArray = #()
	
	fn getAnimProp obj =
	(
		if obj.numSubs > 0 then
		(
			for i = 1 to obj.numSubs do
			(
				getAnimProp obj[i]
			)
		)
		else
		(
			if (obj.controller != undefined) do
			(
				if (keyTest = obj.keys) != undefined and keyTest.count > 0 do
				(
					keytest = obj.keys
					for k in 1 to keyTest.count where keytest[k].selected do
					(
						append selKeyArray keytest[k]
					)
				)
			)
		)
	)
	
	fn GetSelKeys =
	(
		selKeyArray = #()
		for o in selection do
		(
			getAnimProp o
			for i in o.modifiers do
			(
				if (custattributes.count i) > 0 then
				(
					for j = 1 to (custattributes.count i) do
					getAnimProp (custattributes.get i j)
				)
			)
			if (custattributes.count o) > 0 then
			(
				for i = 1 to (custattributes.count $) do (getAnimProp (custattributes.get $ i))
			)
		)
	)

	try
	(
		cui.UnRegisterDialogBar Quick_tangent_RO
		destroyDialog Quick_tangent_RO
	)
	catch()
	rollout Quick_tangent_RO "" width:28 height:200
	(
		button tan_auto 	"" width:22 height:22 pos:[3,3] 		/*offset:[0,-4]*/ 	tooltip:"Set selected keys to auto tangent" images:#("TanUtil_I.bmp", "TanUtil_A.bmp", 32, 13, 29, 13, 13)
		button tan_smooth 	"" width:22 height:22 pos:[3,26] 		/*offset:[0,-4]*/ 	tooltip:"Set selected keys to smooth tangent" images:#("TanUtil_I.bmp", "TanUtil_A.bmp", 32, 1, 17, 1, 1)
		button tan_linear 	"" width:22 height:22 pos:[3,49] 		/*offset:[0,-4]*/ 	tooltip:"Set selected keys to linear tangent" images:#("TanUtil_I.bmp", "TanUtil_A.bmp", 32, 3, 19, 3, 3)
		button tan_slow 	"" width:22 height:22 pos:[3,72] 		/*offset:[0,-4]*/ 	tooltip:"Set selected keys to slow tangent" images:#("TanUtil_I.bmp", "TanUtil_A.bmp", 32, 9, 25, 9, 9)
		button tan_fast 	"" width:22 height:22 pos:[3,95] 		/*offset:[0,-4]*/ 	tooltip:"Set selected keys to fast tangent" images:#("TanUtil_I.bmp", "TanUtil_A.bmp", 32, 7, 23, 7, 7)
		button tan_step 	"" width:22 height:22 pos:[3,118] 		/*offset:[0,-4]*/ 	tooltip:"Set selected keys to stepped tangent" images:#("TanUtil_I.bmp", "TanUtil_A.bmp", 32, 5, 21, 5, 5)
		checkbutton tan_in 	"in" width:66 height:14 pos:[-20,146] 	/*offset:[1,0]*/ 	tooltip:"Affect in tangent" checked:true
		checkbutton tan_out "out" width:66 height:14 pos:[-20,162] 	/*offset:[4,-4]*/ 	tooltip:"Affect out tangent" checked:true
		button VertHoriz "H" width:16 height:16 pos:[6,180] tooltip:"Horizontal layout"
		
		on Quick_tangent_RO open do
		(
			cui.registerdialogbar Quick_tangent_RO style:#(#cui_dock_vert, #cui_floatable, #cui_handles)
		)
		
		on VertHoriz pressed do
		(
			if VertHoriz.text == "H" then
			(
				cui.UnRegisterDialogBar Quick_tangent_RO
				Quick_tangent_RO.width = 164
				Quick_tangent_RO.height = 39
				Quick_tangent_RO.title = "Quick Tangents"
				tan_auto.pos = [8,1]
				tan_smooth.pos = [30,1]
				tan_linear.pos = [52,1]
				tan_slow.pos = [74,1]
				tan_fast.pos = [96,1]
				tan_step.pos = [118,1]
				tan_in.pos = [8,24]
				tan_out.pos = [74,24]
				VertHoriz.pos = [143,10]
				VertHoriz.text = "V"
				VertHoriz.tooltip ="Switch to vertical layout"
				cui.registerdialogbar Quick_tangent_RO style:#(#cui_dock_horz, #cui_floatable, #cui_handles)
			)
			else
			(
				cui.UnRegisterDialogBar Quick_tangent_RO
				Quick_tangent_RO.width = 28
				Quick_tangent_RO.height = 206
				Quick_tangent_RO.title = ""
				tan_auto.pos = [3,3]
				tan_smooth.pos = [3,26]
				tan_linear.pos = [3,49]
				tan_slow.pos = [3,72]
				tan_fast.pos = [3,95]
				tan_step.pos = [3,118]
				tan_in.pos = [-20,146]
				tan_out.pos = [-20,162]
				VertHoriz.pos = [6,180]
				VertHoriz.text = "H"
				VertHoriz.tooltip ="Switch to horizontal layout"
				cui.registerdialogbar Quick_tangent_RO style:#(#cui_dock_vert, #cui_floatable, #cui_handles)
			)
		)
		
		on tan_auto pressed do
		(
			GetSelKeys()
			for kframes in selkeyarray do
			(
				if tan_in.checked then kframes.intangenttype = #auto
				if tan_out.checked then kframes.outtangenttype = #auto
			)
		)
		on tan_smooth pressed do
		(
			GetSelKeys()
			for kframes in selkeyarray do
			(
				if tan_in.checked then kframes.intangenttype = #smooth
				if tan_out.checked then kframes.outtangenttype = #smooth
			)
		)
		on tan_linear pressed do
		(
			GetSelKeys()
			for kframes in selkeyarray do
			(
				if tan_in.checked then kframes.intangenttype = #linear
				if tan_out.checked then kframes.outtangenttype = #linear
			)
		)
		on tan_slow pressed do
		(
			GetSelKeys()
			for kframes in selkeyarray do
			(
				if tan_in.checked then kframes.intangenttype = #slow
				if tan_out.checked then kframes.outtangenttype = #slow
			)
		)
		on tan_fast pressed do
		(
			GetSelKeys()
			for kframes in selkeyarray do
			(
				if tan_in.checked then kframes.intangenttype = #fast
				if tan_out.checked then kframes.outtangenttype = #fast
			)
		)
		on tan_step pressed do
		(
			GetSelKeys()
			for kframes in selkeyarray do
			(
				if tan_in.checked then kframes.intangenttype = #step
				if tan_out.checked then kframes.outtangenttype = #step
			)
		)
	)
	createDialog Quick_tangent_RO --style:#(#style_sysmenu, #style_toolwindow)
)
